<?php
/*
* Get two day GisMeteo meteo info mbot PHP Script v. 1.3 (main code)
* 29.07.2011
* 
* Programmer: Dionys (skiner@inbox.ru)
* GisMeteo info decoder: _sNICKERs_
* 
*  2011 Skurat Denis (a.k.a. Dionys)
* @contact: skiner@inbox.ru
* 
* Based on http://informer.gismeteo.ru/
*/

/* CONFIGURATION */
define('SCRIPT_NAME',		'GisMeteo meteo info');	// Script name.
define('SCRIPT_VERSION',	'1.0.0.3');				// Script version.
define('SYM_ENTER',			chr(0x0D).chr(0x0A));	// Enter
define('WORK_PATH',			realpath('./') .'/mbot/scripts/autoload/GMWeather');
/* END CONFIGURATION */

function mbot_load()
{ 
	if (MBOT_VERSION >= 0x01000000)
	{
		$icon_miranda	= mb_IconLoadSkin(SKINICON_OTHER_MIRANDA);
		$icon_mbot		= 0;

		mb_SelfRegister(MB_EVENT_MENU_COMMAND, 1); 
		mb_SelfSetInfo('GisMeteo Meteo Info v.'.SCRIPT_VERSION.' by Dionys');
		mb_Echo('GisMeteo Meteo Info v.'.SCRIPT_VERSION.' .'.SYM_ENTER);
		mb_MenuAdd('GisMeteo Meteo Info', 0, 'GisMeteoMI', $icon_mbot, 0x00);
		mb_MenuAdd('GisMeteo Meteo Info settings', 0, 'GisMeteoMI_Set', $icon_miranda, 0x00);

		GetConfigData();
	}
	else
	{
		mb_echo(SCRIPT_NAME .': This scripts requires mBot 1.0.0.0 or later!');
	}
}

function GisMeteoMI($param, $cid, $hmenu)
{
	$lang = array();
	$lang = GetLangData();

	$rnd = '0.'.rand(0, 9);
	$town = mt_getvar('GisMeteoMI/town');

	$flashinf = get_gw_data($town, $rnd);
	
	if ($flashinf != 'null')
	{
		$parse = parse_gw_data($flashinf);

		$str_decode = decode_gw_data($parse['current_code'], $parse['current_md']);

		$output	=	$lang['ui_date'].$parse['current_md'].' '.$parse['current_m'].' ('.$parse['current_wd'].')'.SYM_ENTER.
					$lang['ui_tmprtr'].$str_decode['tmprtr'].$lang['tmprtr'].SYM_ENTER.
					$lang['ui_clar'].$str_decode['clar'].SYM_ENTER.
					$lang['ui_press'].$str_decode['press'].$lang['press'].SYM_ENTER.
					$lang['ui_hum'].$str_decode['hum'].$lang['hum'].SYM_ENTER.
					$lang['ui_wind'].$str_decode['wind'].SYM_ENTER.
					$lang['ui_uwind'].$str_decode['uwind'].$lang['uwind'].SYM_ENTER.
					SYM_ENTER;

		$str_decode = decode_gw_data($parse['next_code'], $parse['next_md']);

		$output	.=	$lang['ui_date'].$parse['next_md'].' '.$parse['next_m'].' ('.$parse['next_wd'].')'.SYM_ENTER.
					$lang['ui_tmprtr'].$str_decode['tmprtr'].$lang['tmprtr'].SYM_ENTER.
					$lang['ui_clar'].$str_decode['clar'].SYM_ENTER.
					$lang['ui_press'].$str_decode['press'].$lang['press'].SYM_ENTER.
					$lang['ui_hum'].$str_decode['hum'].$lang['hum'].SYM_ENTER.
					$lang['ui_wind'].$str_decode['wind'].SYM_ENTER.
					$lang['ui_uwind'].$str_decode['uwind'].$lang['uwind'].SYM_ENTER.
					SYM_ENTER;

		$output	.=	$lang['pr_1'].SYM_ENTER.$lang['pr_2'].SYM_ENTER;

		mb_PUAdd(NULL, $lang['ui_town'].$parse['town'], $output, 0, 0, mb_IconLoadSys(IDI_INFORMATION));
	}
	else
	{
		$output	=	$lang['error'].SYM_ENTER.
					SYM_ENTER.
					$lang['pr_1'].SYM_ENTER.$lang['pr_2'].SYM_ENTER;

		mb_PUAdd(NULL, $lang['ui_town'].$lang['unkn'], $output, 0, 0, mb_IconLoadSys(IDI_INFORMATION));
	}
}

function GisMeteoMI_Set($param, $cid, $hmenu)
{
	$lang = array();
	$lang = GetLangData();

	if(file_exists(WORK_PATH.'/GMWeather.cfg')) 
	{
		$f_csg_data = file(WORK_PATH.'/GMWeather.cfg');
		$f_csg_data = trim($f_csg_data[0]);
		$f_csg_data = explode(':', $f_csg_data);
		$f_csg_data[0] = $f_csg_data[0];
		$f_csg_data[1] = $f_csg_data[1];
	}
	else
	{
		$f_csg_data[0] = '27612';
		$f_csg_data[1] = 'En';
	}

	$dlg_lang = mb_DlgGetString($lang['set_1'].' (Ru, En, ...):', 'GisMeteo Meteo Info '.$lang['set_1'], 0x08, 0, 0, $f_csg_data[1]);
	if ($dlg_lang != '')
	{
		$dlg_town = mb_DlgGetString($lang['set_2'].' (Moscow 27612 ...):', 'GisMeteo Meteo Info '.$lang['set_2'], 0x08, 0, 0, $f_csg_data[0]);
	}

	if ($dlg_lang != '' && $dlg_town != '')
	{
		$fhandle = fopen (WORK_PATH.'/GMWeather.cfg', 'wb');
		fwrite($fhandle, $dlg_town.':'.$dlg_lang);
		fclose($fhandle);

		mt_setvar('GisMeteoMI/town', $dlg_town);
		mt_setvar('GisMeteoMI/lang', $dlg_lang);
	}
}

function GetConfigData()
{
	if(file_exists(WORK_PATH.'/GMWeather.cfg')) 
	{
		$f_csg_data = file(WORK_PATH.'/GMWeather.cfg');
		$f_csg_data = trim($f_csg_data[0]);
		$f_csg_data = explode(':', $f_csg_data);
		$f_csg_data[0] = $f_csg_data[0];
		$f_csg_data[1] = $f_csg_data[1];
	}
	else
	{
		$f_csg_data[0] = '27612';
		$f_csg_data[1] = 'En';
		
		$fhandle = fopen (WORK_PATH.'/GMWeather.cfg', 'wb');
		fwrite($fhandle, $f_csg_data[0].':'.$f_csg_data[1]);
		fclose($fhandle);
	}
	
	mt_setvar('GisMeteoMI/town', $f_csg_data[0]);
	mt_setvar('GisMeteoMI/lang', $f_csg_data[1]);
}

function GetLangData()
{
	$lang_code = mt_getvar('GisMeteoMI/lang'); 

	if(file_exists(WORK_PATH.'/GMWeather_'.$lang_code.'.php')) include WORK_PATH.'/GMWeather_'.$lang_code.'.php';
	else include WORK_PATH.'/GMWeather_En.php';

	return $lang;
}

/* get data */
function get_gw_data($town, $rnd)
{
	$timeout = 1;
	$recv = 'http://img.gismeteo.ru/flashinf/FLB'.$town.'.TXT?'.$rnd;

	$ihandle = @fopen($recv, 'rb');
	@stream_set_timeout($ihandle, $timeout);

	if ($ihandle)
	{
		while(!feof($ihandle))
		{
			$idata = fread($ihandle, 128);
			$flashinf .= $idata;
		}

		fclose($ihandle);
	}

	if (empty($flashinf))
	{
		$flashinf = 'null';
	}

	return $flashinf;
}
/* parse data */
function parse_gw_data($str)
{
	$lang = array();
	$lang = GetLangData();
	$lang_code = mt_getvar('GisMeteoMI/lang');

	$parse = array();
	$exp_str = array();
	$exp_str = explode ('&', $str);
	$town_indx = 0;
	if($lang_code == 'Ru') $town_str = 'townru=';
	else $town_str = 'townen=';
	$dayn_indx = 'current';
	$daten_indx = 'current';
	$monthn_indx = 'current';
	$wn_indx = 'current';

	for($i = 0; $i < count($exp_str); $i ++)
	{
		if (substr($exp_str[$i], 0, 7) == "$town_str" && $town_indx == 0)
		{
			$parse['town'] = substr($exp_str[$i], 7);	//  
			$town_indx = 1;
		}
		if (substr($exp_str[$i], 0, 5) == 'dayn=' && $dayn_indx == 'current')
		{
			$parse['current_wd'] = intval(substr($exp_str[$i], 5));	//    
			$dayn_indx = 'next';
		}
		else if (substr($exp_str[$i], 0, 5) == 'dayn=' && $dayn_indx == 'next')
		{
			$parse['next_wd'] = intval(substr($exp_str[$i], 5));	//    
		}
		if (substr($exp_str[$i], 0, 6) == 'daten=' && $daten_indx == 'current')
		{
			$parse['current_md'] = intval(substr($exp_str[$i], 6));	//    
			$daten_indx = 'next';
		}
		else if (substr($exp_str[$i], 0, 6) == 'daten=' && $daten_indx == 'next')
		{
			$parse['next_md'] = intval(substr($exp_str[$i], 6));	//    
		}
		if (substr($exp_str[$i], 0, 7) == 'monthn=' && $monthn_indx == 'current')
		{
			$parse['current_m'] = intval(substr($exp_str[$i], 7));	//   
			$monthn_indx = 'next';
		}
		else if (substr($exp_str[$i], 0, 7) == 'monthn=' && $monthn_indx == 'next')
		{
			$parse['next_m'] = intval(substr($exp_str[$i], 7));	//   
		}
		if (substr($exp_str[$i], 0, 3) == 'wn=' && $wn_indx == 'current')
		{
			$parse['current_code'] = substr($exp_str[$i], 3);	//   
			$wn_indx = 'next';
		}
		else if (substr($exp_str[$i], 0, 3) == 'wn=' && $wn_indx == 'next')
		{
			$parse['next_code'] = substr($exp_str[$i], 3);	//   
		}		
	}

	switch($parse['current_wd'])
	{
		case 1: $parse['current_wd'] = $lang['week_1']; break;
		case 2: $parse['current_wd'] = $lang['week_2']; break;
		case 3: $parse['current_wd'] = $lang['week_3']; break;
		case 4: $parse['current_wd'] = $lang['week_4']; break;
		case 5: $parse['current_wd'] = $lang['week_5']; break;
		case 6: $parse['current_wd'] = $lang['week_6']; break;
		case 7: $parse['current_wd'] = $lang['week_7']; break;
		default : $parse['current_wd'] = $lang['unkn'];
	}

	switch($parse['next_wd'])
	{
		case 1: $parse['next_wd'] = $lang['week_1']; break;
		case 2: $parse['next_wd'] = $lang['week_2']; break;
		case 3: $parse['next_wd'] = $lang['week_3']; break;
		case 4: $parse['next_wd'] = $lang['week_4']; break;
		case 5: $parse['next_wd'] = $lang['week_5']; break;
		case 6: $parse['next_wd'] = $lang['week_6']; break;
		case 7: $parse['next_wd'] = $lang['week_7']; break;
		default : $parse['next_wd'] = $lang['unkn'];
	}

	switch($parse['current_m'])
	{
		case 1: $parse['current_m'] = $lang['year_1']; break;
		case 2: $parse['current_m'] = $lang['year_2']; break;
		case 3: $parse['current_m'] = $lang['year_3']; break;
		case 4: $parse['current_m'] = $lang['year_4']; break;
		case 5: $parse['current_m'] = $lang['year_5']; break;
		case 6: $parse['current_m'] = $lang['year_6']; break;
		case 7: $parse['current_m'] = $lang['year_7']; break;
		case 8: $parse['current_m'] = $lang['year_8']; break;
		case 9: $parse['current_m'] = $lang['year_9']; break;
		case 10: $parse['current_m'] = $lang['year_10']; break;
		case 11: $parse['current_m'] = $lang['year_11']; break;
		case 12: $parse['current_m'] = $lang['year_12']; break;
		default : $parse['current_m'] = $lang['unkn'];
	}

	switch($parse['next_m'])
	{
		case 1: $parse['next_m'] = $lang['year_1']; break;
		case 2: $parse['next_m'] = $lang['year_2']; break;
		case 3: $parse['next_m'] = $lang['year_3']; break;
		case 4: $parse['next_m'] = $lang['year_4']; break;
		case 5: $parse['next_m'] = $lang['year_5']; break;
		case 6: $parse['next_m'] = $lang['year_6']; break;
		case 7: $parse['next_m'] = $lang['year_7']; break;
		case 8: $parse['next_m'] = $lang['year_8']; break;
		case 9: $parse['next_m'] = $lang['year_9']; break;
		case 10: $parse['next_m'] = $lang['year_10']; break;
		case 11: $parse['next_m'] = $lang['year_11']; break;
		case 12: $parse['next_m'] = $lang['year_12']; break;
		default : $parse['next_m'] = $lang['unkn'];
	}

	return $parse;
}
/* decode data */
function decode_gw_data($gw_code, $parse_date)
{
	$lang = array();
	$lang = GetLangData();

	$codedString = 'sxkcogzitaq0my3nbw9d1rve5u7f8l4j2p6h';
	$str_decode = array();

	if (strlen($gw_code) < 7)
	{
		while (strlen($gw_code) < 7) $gw_code .= 's'.$gw_code;
	}

	$str_decode['tmp1']		= strpos($codedString, substr($gw_code, 0, 1))*elevate_number(36, 2) + strpos($codedString, substr($gw_code, 1, 1))*elevate_number(36, 1) + strpos($codedString, substr($gw_code, 2, 1))*elevate_number(36, 0);
	$str_decode['tmp2']		= strpos($codedString, substr($gw_code, 3, 1))*elevate_number(36, 3) + strpos($codedString, substr($gw_code, 4, 1))*elevate_number(36, 2) + strpos($codedString, substr($gw_code, 5, 1))*elevate_number(36, 1) + strpos($codedString, substr($gw_code, 6, 1))*elevate_number(36, 0);
	$str_decode['uwind']	= floor($str_decode['tmp1']/1000); //  
	$str_decode['tmp1']		= $str_decode['tmp1'] - $str_decode['uwind']*1000;
	$str_decode['hum']		= floor($str_decode['tmp1']/10); // 
	$str_decode['clar']		= $str_decode['tmp1'] - $str_decode['hum']*10;  // 
	$str_decode['tmprtr']	= floor($str_decode['tmp2']/10000) - 70 - $parse_date; // 
	$str_decode['tmp2']		= $str_decode['tmp2'] - ($str_decode['tmprtr'] + 70 + $parse_date)*10000;
	$str_decode['press']	= floor($str_decode['tmp2']/10) + 500; // 
	$str_decode['wind']		= $str_decode['tmp2'] - ($str_decode['press'] - 500)*10; //  

	switch($str_decode['clar'])
	{
		case 0: $str_decode['clar'] = $lang['error']; break;
		case 1: $str_decode['clar'] = $lang['clar_1']; break;
		case 2: $str_decode['clar'] = $lang['clar_2']; break;
		case 3: $str_decode['clar'] = $lang['clar_3']; break;
		case 4: $str_decode['clar'] = $lang['clar_4']; break;
		case 5: $str_decode['clar'] = $lang['clar_5']; break;
		case 6: $str_decode['clar'] = $lang['clar_6']; break;
		case 7: $str_decode['clar'] = $lang['clar_7']; break;
		case 8: $str_decode['clar'] = $lang['clar_8']; break;
		case 9: $str_decode['clar'] = $lang['clar_9']; break;
		default : $str_decode['clar'] = $lang['unkn'];
	}

	switch($str_decode['wind'])
	{
		case 0: $str_decode['wind'] = $lang['wind_0']; break;
		case 1: $str_decode['wind'] = $lang['wind_1']; break;
		case 2: $str_decode['wind'] = $lang['wind_2']; break;
		case 3: $str_decode['wind'] = $lang['wind_3']; break;
		case 4: $str_decode['wind'] = $lang['wind_4']; break;
		case 5: $str_decode['wind'] = $lang['wind_5']; break;
		case 6: $str_decode['wind'] = $lang['wind_6']; break;
		case 7: $str_decode['wind'] = $lang['wind_7']; break;
		default : $str_decode['wind'] = $lang['unkn'];
	}
	
	return $str_decode;
}
/* elevate the number */
function elevate_number($number, $elevate)
{
	$number = intval($number);
	$elevate = intval($elevate);
	$current_number = $number;
	$elevate_abs = abs($elevate);

	if ($elevate == 1) return $number;
	if ($elevate == -1) return 1/$number;
	if ($elevate == 0) return 1;

	while($elevate_abs > 1)
	{
		$number = $number*$current_number;
		$elevate_abs --;
	}

	if ($elevate < 0) return 1/$number;	
	else return $number;
}
?>